#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Diagnostics;
using Syncfusion.Styles;

namespace GridSample
{
	public class Form1 : System.Windows.Forms.Form
	{
		internal Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		internal System.Windows.Forms.Button printPreviewButton;
		internal System.Windows.Forms.PropertyGrid propertyGrid1;
		internal Syncfusion.Windows.Forms.SplitterControl splitterControl1;
		internal System.Windows.Forms.ListBox output;
		internal DataSet1 dataSet11;
		internal System.Windows.Forms.Button buttonCauseValidation;
		internal System.Windows.Forms.Button buttonNoValidation;
		private System.Windows.Forms.CheckBox checkBoxMouseMessage;
		internal System.ComponentModel.Container components = null;
		private System.Windows.Forms.CheckBox checkBoxEnableTracing;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;
		CurrentCellEventTracer tracer;

		public Form1()
		{
			dataSet11 = new DataSet1();

			InitializeComponent();

			this.ActiveControl = this.splitterControl1;

			splitterControl1.ThemesEnabled = true;

			gridControl1.Initialize();
			gridControl1.ThemesEnabled = true;
			gridControl1.ControllerOptions &= ~(GridControllerOptions.OleDataSource|GridControllerOptions.OleDropTarget);
			gridControl1.CurrentCell.MoveTo(1, 1);
			gridControl1.BaseStylesMap["Header"].StyleInfo.Enabled = false;
			gridControl1.VScrollPixel = true;
			gridControl1.HScrollPixel = true;


			tracer = new CurrentCellEventTracer(this.splitterControl1, this.output);
			checkBoxMouseMessage.Checked = tracer.DisplayMouseMessages;
			checkBoxEnableTracing.Checked = tracer.Enabled;

			GridStyleInfo heading1 = gridControl1.BaseStylesMap["Heading 1"].StyleInfo;
			heading1.TextColor = Color.Blue;
			heading1.Font.Size = 14;
			heading1.Font.Bold = true;

			GridStyleInfo heading2 = gridControl1.BaseStylesMap["Heading 2"].StyleInfo;
			heading2.TextColor = Color.Blue;
			heading2.Font.Size = 14;
			heading2.Font.Bold = true;

			this.output.ContextMenu = this.contextMenu1;

			this.propertyGrid1.CausesValidation = false;
			this.splitter1.CausesValidation = false;
			this.panel1.CausesValidation = false;
			this.panel2.CausesValidation = false;

			// read the data from a local XML file
			ReadXml(this.dataSet11, @"Data\GDBDdata.XML");
		}

		//hunt the folder tree for the data\*.xml file..
		void ReadXml(DataSet ds, string xmlFileName)
		{
			if (ds == null)
				return;

			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					break;
				}
				xmlFileName = @"..\" + xmlFileName;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.printPreviewButton = new System.Windows.Forms.Button();
			this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
			this.splitterControl1 = new Syncfusion.Windows.Forms.SplitterControl();
			this.output = new System.Windows.Forms.ListBox();
			this.buttonCauseValidation = new System.Windows.Forms.Button();
			this.buttonNoValidation = new System.Windows.Forms.Button();
			this.checkBoxMouseMessage = new System.Windows.Forms.CheckBox();
			this.checkBoxEnableTracing = new System.Windows.Forms.CheckBox();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.splitterControl1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.ColCount = 12;
			this.gridControl1.HorizontalThumbTrack = true;
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 120;
			this.gridControl1.Size = new System.Drawing.Size(507, 315);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.VerticalThumbTrack = true;
			this.gridControl1.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
			this.gridControl1.SelectionChanged += new Syncfusion.Windows.Forms.Grid.GridSelectionChangedEventHandler(this.grid_SelectionChanged);
			// 
			// printPreviewButton
			// 
			this.printPreviewButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.printPreviewButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.printPreviewButton.Location = new System.Drawing.Point(248, 8);
			this.printPreviewButton.Name = "printPreviewButton";
			this.printPreviewButton.Size = new System.Drawing.Size(240, 23);
			this.printPreviewButton.TabIndex = 1;
			this.printPreviewButton.Text = "Print Preview";
			this.printPreviewButton.Click += new System.EventHandler(this.printPreviewButton_Click);
			// 
			// propertyGrid1
			// 
			this.propertyGrid1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.propertyGrid1.CommandsVisibleIfAvailable = true;
			this.propertyGrid1.LargeButtons = false;
			this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.propertyGrid1.Location = new System.Drawing.Point(560, 40);
			this.propertyGrid1.Name = "propertyGrid1";
			this.propertyGrid1.Size = new System.Drawing.Size(208, 320);
			this.propertyGrid1.TabIndex = 2;
			this.propertyGrid1.Text = "propertyGrid1";
			this.propertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
			this.propertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// splitterControl1
			// 
			this.splitterControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.splitterControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																						   this.gridControl1});
			this.splitterControl1.Location = new System.Drawing.Point(16, 40);
			this.splitterControl1.Name = "splitterControl1";
			this.splitterControl1.Size = new System.Drawing.Size(528, 336);
			this.splitterControl1.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both;
			this.splitterControl1.TabIndex = 6;
			this.splitterControl1.ThemesEnabled = true;
			this.splitterControl1.PaneClosing += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.splitterControl1_PaneClosing);
			this.splitterControl1.PaneCreated += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.splitterControl1_PaneCreated);
			// 
			// output
			// 
			this.output.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.output.Location = new System.Drawing.Point(16, 16);
			this.output.Name = "output";
			this.output.ScrollAlwaysVisible = true;
			this.output.Size = new System.Drawing.Size(528, 160);
			this.output.TabIndex = 4;
			// 
			// buttonCauseValidation
			// 
			this.buttonCauseValidation.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.buttonCauseValidation.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonCauseValidation.Location = new System.Drawing.Point(592, 24);
			this.buttonCauseValidation.Name = "buttonCauseValidation";
			this.buttonCauseValidation.Size = new System.Drawing.Size(152, 24);
			this.buttonCauseValidation.TabIndex = 5;
			this.buttonCauseValidation.Text = "CausesValidation = true";
			// 
			// buttonNoValidation
			// 
			this.buttonNoValidation.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.buttonNoValidation.CausesValidation = false;
			this.buttonNoValidation.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonNoValidation.Location = new System.Drawing.Point(592, 64);
			this.buttonNoValidation.Name = "buttonNoValidation";
			this.buttonNoValidation.Size = new System.Drawing.Size(152, 24);
			this.buttonNoValidation.TabIndex = 5;
			this.buttonNoValidation.Text = "CausesValidation = false";
			// 
			// checkBoxMouseMessage
			// 
			this.checkBoxMouseMessage.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.checkBoxMouseMessage.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.checkBoxMouseMessage.Location = new System.Drawing.Point(592, 128);
			this.checkBoxMouseMessage.Name = "checkBoxMouseMessage";
			this.checkBoxMouseMessage.Size = new System.Drawing.Size(152, 32);
			this.checkBoxMouseMessage.TabIndex = 7;
			this.checkBoxMouseMessage.Text = "Trace Mouse and Control Messages";
			this.checkBoxMouseMessage.CheckedChanged += new System.EventHandler(this.checkBoxMouseMessage_CheckedChanged);
			// 
			// checkBoxEnableTracing
			// 
			this.checkBoxEnableTracing.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.checkBoxEnableTracing.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.checkBoxEnableTracing.Location = new System.Drawing.Point(592, 104);
			this.checkBoxEnableTracing.Name = "checkBoxEnableTracing";
			this.checkBoxEnableTracing.Size = new System.Drawing.Size(152, 16);
			this.checkBoxEnableTracing.TabIndex = 7;
			this.checkBoxEnableTracing.Text = "Enable Tracing";
			this.checkBoxEnableTracing.CheckedChanged += new System.EventHandler(this.checkBoxEnableTracing_CheckedChanged);
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "&Clear Window";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.printPreviewButton,
																				 this.splitterControl1,
																				 this.propertyGrid1});
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(792, 384);
			this.panel1.TabIndex = 8;
			// 
			// panel2
			// 
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.output,
																				 this.checkBoxEnableTracing,
																				 this.buttonNoValidation,
																				 this.checkBoxMouseMessage,
																				 this.buttonCauseValidation});
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 384);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(792, 182);
			this.panel2.TabIndex = 9;
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 384);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(792, 8);
			this.splitter1.TabIndex = 10;
			this.splitter1.TabStop = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 566);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.splitter1,
																		  this.panel2,
																		  this.panel1});
			this.Name = "Form1";
			this.Text = "Combobox Cells...";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.splitterControl1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
#endregion


		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		private void printPreviewButton_Click(object sender, System.EventArgs e)
		{
			if (gridControl1 != null)
			{
				try 
				{
					GridControl grid = this.splitterControl1.ActivePane as GridControl;
					if (grid != null)
					{
						GridPrintDocument pd = new GridPrintDocument(gridControl1, true); //Assumes the default printer

						PrintPreviewDialog dlg = new PrintPreviewDialog() ;
						dlg.Document = pd;
						dlg.ShowDialog();
					}
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview the file to print - " + ex.Message);
				}
			}

		}

		private void checkBoxMouseMessage_CheckedChanged(object sender, System.EventArgs e)
		{
			tracer.DisplayMouseMessages = checkBoxMouseMessage.Checked;
		}

		private void checkBoxEnableTracing_CheckedChanged(object sender, System.EventArgs e)
		{
			tracer.Enabled = this.checkBoxEnableTracing.Checked;
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			this.output.Items.Clear();
		}

		private void splitterControl1_PaneClosing(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			GridControl grid = (GridControl) e.Control;
			grid.CurrentCellMoved -= new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
			grid.SelectionChanged -= new GridSelectionChangedEventHandler(grid_SelectionChanged);
		}

		private void splitterControl1_PaneCreated(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			GridControl grid = (GridControl) e.Control;
			grid.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
			grid.SelectionChanged += new GridSelectionChangedEventHandler(grid_SelectionChanged);
		}

		private void grid_CurrentCellMoved(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventArgs e)
		{
			grid = (GridControlBase) sender;
			DelayRefreshPropertyGrid(GridRangeInfo.Cell(grid.CurrentCell.RowIndex, grid.CurrentCell.ColIndex), 50);
		}

		private void grid_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
		{
			DelayRefreshPropertyGrid(e.Range, 200);
		}

		private GridRangeInfo range = GridRangeInfo.Empty;
		private GridStyleInfo style = null;
		private GridControlBase grid = null;
		bool refreshPropertyGridNextIdle = false;
		Timer refreshTimer = null;

		private void DelayRefreshPropertyGrid(GridRangeInfo range, int interval)
		{
			if (refreshTimer != null)
			{
				refreshPropertyGridNextIdle = false;
				refreshTimer.Stop();
			}
			else
			{
				refreshTimer = new Timer();
				refreshTimer.Interval = interval;
				refreshTimer.Tick += new EventHandler(DelayedRefreshPropertyGrid);
			}
			refreshTimer.Start();
			refreshPropertyGridNextIdle = true;
			this.range = range;
		}

		void DelayedRefreshPropertyGrid(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfo();
			Timer t = sender as Timer;
			t.Dispose();
			this.refreshTimer = null;

			if (refreshPropertyGridNextIdle)
				RefreshPropertyGrid();
		}

		public void RefreshPropertyGrid()
		{
			{
				refreshPropertyGridNextIdle = false;
				if (style != null)
				{
					style.Changed -= new StyleChangedEventHandler(GridStyleInfoChanged);
				}
				
				grid = (GridControlBase) splitterControl1.ActivePane;
				style = grid.Model.GetCombinedStyle(range);
				if (style != null)
				{
					propertyGrid1.SelectedObject = style;
					style.Changed += new StyleChangedEventHandler(GridStyleInfoChanged);
				}
				else
					range = GridRangeInfo.Empty;
			}
		}

		public void ShowPropertyGridItem(string category, string label)
		{
			RefreshPropertyGrid(); 
			GridItem gi = propertyGrid1.SelectedGridItem;
			while (gi != null && gi.GridItemType != GridItemType.Root)
				gi = gi.Parent;

			if (gi != null)
			{
				// Categories
				GridItemCollection categories = gi.GridItems;
				GridItem sliderCategory = categories[category];
				if (sliderCategory != null)
				{
					GridItemCollection items = sliderCategory.GridItems;
					GridItem item;
					if (label == "")
						item = items[Math.Min(10, items.Count-1)];
					else
						item = items[label];
					item.Select();
					if (item.Expandable)
					{
						propertyGrid1.ExpandAllGridItems();
						items = item.GridItems;
						items[Math.Min(10, items.Count-1)].Select();
					}
				}
			}
			RefreshPropertyGrid(); 
		}

		void GridStyleInfoChanged(object sender, StyleChangedEventArgs e)
		{
			if (!refreshPropertyGridNextIdle && !range.IsEmpty && grid != null && style != null)
			{
				grid.Model.ChangeCells(range, style, StyleModifyType.Changes);
			}
		}

		private void splitter1_SplitterMoved(object sender, System.Windows.Forms.SplitterEventArgs e)
		{
		
		}

	}


}
